<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Learn jQuery</title>
	<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.13.2/themes/smoothness/jquery-ui.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.4/jquery.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.13.2/jquery-ui.min.js"></script>
	<script>
		$(document).ready(function(){
			// datepicker
			$("#date").datepicker();
			
			// autocomplete
			$(function(){
			    let progLang = [
			        "ActionScript",  
			        "AppleScript",  
			        "Asp",  
			        "BASIC",  
			        "C",  
			        "C++",  
			        "Clojure",  
			        "COBOL",  
			        "ColdFusion",  
			        "Erlang",  
			        "Fortran",  
			        "Groovy",  
			        "Haskell",  
			        "Java",  
			        "JavaScript",  
			        "Lisp",  
			        "Perl",  
			        "PHP",  
			        "Python",  
			        "Ruby",  
			        "Scala",  
			        "Scheme"  
			    ];
			    $("#progLang").autocomplete({
			        source:progLang
			    });
			});

			// attr
			$("#btnChangeSize").click(function(){
			    $("#lakeAndNatureImg").attr("width", "800")
			});

			// show and hide
			$("#btnHide").click(function(){
			    $("#hide").hide();
			});

			$("#btnShow").click(function(){
			    $("#hide").show();
			});

			// trim
			$(function(){
			    let str="           String with spaces            ";
			    $("#originalStr").html("Original String:'" +str+ "'");
			    $("#trimmedStr").html("Trimmed String: '" +$.trim(str)+ "'")
			});

			// ajax
			 $("#catFactsBtn").click(function(){
                $.ajax({url: "https://catfact.ninja/fact",
                method: "GET",
                dataType:"json",
                success: function(result){
                    $("#catFacts").html(result.fact);
                }});
            });

			// dialog box
			 $(function(){
			     $("#dialogBox").dialog({
			         autoOpen:false,
			     });
			     $("#seeDialog").click(function(){
			         $("#dialogBox").dialog("open");
			     });
			});

			// tabs
			$("#tabs").tabs();

			// val
            $("#putValue").click(function(){
                $("#fullname").val("Danbell Villacampa");
            });

             // css
            $("#makeItRed").click(function(){
                $("#lorem").css("color", "red");
            });

            // serialize
            $("#getValue").click(function(){
                $("#serialized").html($("#firstname", "#lastname").serialize());
            });

            // each
            $("#changeToBlue").click(function(){
                $(".progLang").each(function(){
                    $(this).css("color", "blue");
                });
            });

            // bind
            $("#alert").bind("click", function(){
                alert("Hello from alert!")
            });

            // parent
            $("#parentLorem").parent().css({"margin": "0px 5px", "border": "2px solid red"});

            // clone
            $("#clonebtn").click(function(){
                $("#cloneMsg").clone().appendTo("body");
            });

            // console.log
            $(function(){
                let arr = ["PHP", "JS", "C++", "C#", "Java"];
                console.log(arr);
            })
		})
	</script>
	<link rel="stylesheet" type="text/css" href="learnJQ.css">
</head>
<body>
	<div id="mainJquery">
			<button id="back"><a href="./index.html">Go back</a></button>
			<h1>Learn jQuery</h1>
			<h2>What is jQuery?</h2>
			<ul>
				<li>
					jQuery is a lightweight, "write less, do more", JavaScript library.
				</li>
				<li>
					The purpose of jQuery is to make it much easier to use JavaScript on your website.
				</li>
				<li>
					jQuery takes a lot of common tasks that require many lines of JavaScript code to accomplish, and wraps them into methods that you can call with a single line of code.
				</li>
				<li>
					jQuery also simplifies a lot of the complicated things from JavaScript, like AJAX calls and DOM manipulation.
				</li>
			</ul>
			<h2>What can we do in jQuery?</h2>

			<!-- .ready() -->
			<h3 class="lesson">.ready()</h3>
			<p class="meaning">Use ready() to make a function available after the document is loaded</p>

			<!-- .datepicker() -->
			<h3 class="lesson">.datepicker()</h3>
			<p class="meaning">Select a date from a popup or inline calendar</p>
			<label for="date">Date:</label>
			<input type="text" id="date">

			<!-- autocomplete -->
			<h3 class="lesson">.autocomplete()</h3>
			<p class="meaning">Enables users to quickly find and select from a pre-populated list of values as they type, leveraging searching and filtering.</p>
			<label for="progLang">Programming Languages:</label>
		    <input type="text" id="progLang">
			
			<!-- selectors -->
			<h3 class="lesson">Selectors</h3>
			<p class="meaning">The jQuery element selector selects elements based on the element name.</p>

			<!-- attr() -->
			<h3 class="lesson">.attr()</h3>
			<p class="meaning">The attr() method sets or returns attributes and values of the selected elements.</p>
			<img src="https://th.bing.com/th/id/OIP.iSu2RcCcdm78xbxNDJMJSgHaEo?pid=ImgDet&rs=1" alt="Lake and nature" id="lakeAndNatureImg">
			<br>
			<br>
			<button id="btnChangeSize">Change the Size of the Image</button>

			<!-- show() and hide() -->
			<h3 class="lesson">.show() and .hide()</h3>
			<p class="meaning">The show() method shows the hidden, selected elements. On the other hand, the hide() method hides the selected elements.</p>
			<p id="hide">Click the button to hide this paragraph!</p>
			<button id="btnHide">Hide</button>
			<button id="btnShow">Show</button>

			<!-- trim() -->
			<h3 class="lesson">.trim()</h3>
			<p class="meaning"> Remove the whitespace from the beginning and end of a string.</p>
			<pre id="originalStr"></pre>
			<pre id="trimmedStr"></pre>

			<!-- ajax() -->
			<h3 class="lesson">.ajax()</h3>
			<p>The ajax() method is used to perform an AJAX (asynchronous HTTP) request. All jQuery AJAX methods use the ajax() method. This method is mostly used for requests where the other methods cannot be used.</p>
			<button id="catFactsBtn">Give me some cats fact</button>
		    <p id="catFacts"></p>

		    <!-- dialog box -->
		    <h3 class="lesson">.dialog()</h3>
		    <p>Open content in an interactive overlay.</p>
		    <p id="dialogBox">Lorem ipsum dolor sit, amet consectetur adipisicing elit. Adipisci blanditiis reprehenderit repudiandae necessitatibus nobis, aspernatur tenetur doloribus, ab quibusdam facere accusamus impedit quis numquam quisquam est ratione consequuntur sequi labore.</p>
		    <button id="seeDialog">Click to see Dialog Box</button>

		    <!-- .tabs() -->
		    <h3 class="lesson">.tabs()</h3>
		    <p>A single content area with multiple panels, each associated with a header in a list.</p>
		    <div id="tabs">
		        <ul>
		            <li><a href="#javascript">JavaScript</a></li>
		            <li><a href="#php">PHP</a></li>
		            <li><a href="#jquery">jQuery</a></li>
		        </ul>
		        <p id="javascript">This is JavaScript</p>
		        <p id="php">This is PHP</p>
		        <p id="jquery">This is jQuery</p>
		    </div>

		    <!-- val() -->
		    <h3 class="lesson">.val()</h3>
		    <p>The val() method returns or sets the value attribute of the selected elements.</p>
		    <label for="fullname">Full Name:</label>
		    <input type="text" id="fullname">
		    <button id="putValue">Click Me!</button>

		    <!-- css() -->
		    <h3 class="lesson">.css()</h3>
		    <p>The css() method sets or returns one or more style properties for the selected elements.</p>
		    <p id="lorem">Lorem ipsum dolor sit amet consectetur adipisicing elit. Eaque fugit non impedit sunt aliquam totam modi, fuga ab delectus labore sed eum laudantium ipsum dignissimos eveniet dolorum illum, similique enim.</p>
		    <button id="makeItRed">Make Paragraph Red</button>

		    <!-- serialize() -->
		    <h3 class="lesson">.serialize()</h3>
		    <p>The serialize() method creates a URL encoded text string by serializing form values.</p>
		    <form>
		    	<label for="firstname">Firstname:</label>
		        <input type="text" name="firstname" id="firstname">
		        <label for="lastname">Lastname:</label>
		        <input type="text" name="lastname" id="lastname">
				<button id="getValue">Serialize from values</button>
		    </form>
		    <p id="serialized"></p>

		    <!-- each() -->
		    <h3 class="lesson">.each()</h3>
		    <p>Iterate over a jQuery object, executing a function for each matched element.</p>
		    <h4>Programming Language</h4>
		    <ol>
		        <li class="progLang">PHP</li>
		        <li class="progLang">JS</li>
		        <li class="progLang">Java</li>
		        <li class="progLang">C#</li>
		        <li class="progLang">C++</li>
		    </ol>
		    <button id="changeToBlue">Change to blue</button>

		    <!-- bind() -->
		    <h3 class="lesson">.bind()</h3>
		    <p> The bind() method attaches one or more event handlers for selected elements, and specifies a function to run when the event occurs.</p>
		    <p id="alert">Click me to see Alert!</p>

		    <!-- parent -->
		    <h3 class="lesson">.parent()</h3>
		    <p> The parent() method returns the direct parent element of the selected element.</p>
		    <div>
		        <p id="parentLorem">Lorem ipsum dolor sit amet consectetur adipisicing elit. Quis sunt ratione sed quas optio voluptatibus, alias facilis accusantium perspiciatis repudiandae provident maxime iure repellat dolorum nisi enim fugiat ut veritatis?
		        Vero, doloremque porro sapiente minus voluptatibus blanditiis sit totam quibusdam nihil consequatur ea nesciunt doloribus, laudantium molestiae esse illo id cumque dolores commodi quo explicabo! Illum vel debitis autem eum!
		        Quidem sed libero possimus est eos nihil id. Autem quidem ad culpa commodi magnam provident deleniti sunt. Perferendis dolor, laudantium iusto est beatae cupiditate, rem praesentium modi molestias cum adipisci.
		        Delectus error nostrum pariatur minima debitis assumenda iusto illum, amet quisquam mollitia, dignissimos inventore sequi obcaecati, recusandae hic rerum ex eaque dicta alias numquam placeat corporis quis expedita laudantium. Quidem?
		        Quas, deserunt perspiciatis natus obcaecati impedit tempora animi vitae sint vero unde eos veniam minus, exercitationem consectetur provident voluptatem libero eaque, dicta doloribus placeat harum voluptates nesciunt! Dolorum, vitae tempora.
		        Assumenda illum blanditiis, culpa, accusamus itaque odit explicabo quae laboriosam, doloremque ut accusantium nihil atque quas aspernatur id. Pariatur laboriosam cum sequi quaerat necessitatibus placeat ipsum nihil totam eveniet reprehenderit.
		        Soluta dolores impedit eligendi doloribus, natus voluptate non alias quaerat. Doloribus labore quibusdam earum voluptatem illo ratione in enim. Corrupti, ipsum possimus! Sed, consequatur! Recusandae tempora minima suscipit ad. Fugiat?
				</p>
		    </div>

		    <!-- clone() -->
		   	<h3 class="lesson">.clone()</h3>
		   	<p>The clone() method makes a copy of selected elements,including child nodes, text and attributes.</p>
		   	<p id="cloneMsg">Clone Me!</p>
		   	<button id="clonebtn">Clone it!</button>
	</div>
</body>
</html>